Scriptname _SLPNPC extends activemagiceffect  

;====================================================================================

Armor Head
Armor Chest
Armor Boots
Armor Hands
Armor Cloak
Armor Backpack
Armor ShieldObj
Armor RandomRobes

Weapon WeaponObj

_SLPQuestScript Property _SLPQuest Auto

Actor targ

Int Snore
Int iRandomIndex

Import Actor

;====================================================================================

Function EquipObject(Form Armor1)
	If Armor1
		targ.EquipItem(Armor1)
	EndIf
EndFunction

Function UnequipObject(Form Armor2)
	If Armor2
		targ.UnequipItem(Armor2)
	EndIf
EndFunction

;====================================================================================
 
Event OnEffectStart(Actor akTarget, Actor akCaster)
	targ = akTarget
	If targ.GetFactionReaction(_SLPQuest.PlayerRef) == 1 || targ.IsInFaction(_SLPQuest.BanditFaction)
		If _SLPQuest.SleepHostile == 2
			GoToState("Bandit")
		ElseIf _SLPQuest.SleepHostile == 1
			GoToState("Naked")
		ElseIf _SLPQuest.SleepHostile == 3
			If Utility.RandomInt(0, 1) == 0
				GoToState("Bandit")
			Else
				GoToState("Naked")
			EndIf
		Else
			GoToState("Snore")
		EndIf
	Else
		If _SLPQuest.Sleepwear == 2
			GoToState("Robe")
		ElseIf _SLPQuest.Sleepwear == 1
			GoToState("Naked")
		ElseIf _SLPQuest.Sleepwear == 3
			If Utility.RandomInt(0, 1) == 0
				GoToState("Robe")
			Else
				GoToState("Naked")
			EndIf
		Else
			GoToState("Snore")
		EndIf
	EndIf
EndEvent

;====================================================================================

State Naked

	Event OnBeginState()
		If targ
			If _SLPQuest.SKSEInstalled
				Head = targ.GetWornForm(0x00000002) as Armor
				UnequipObject(Head)

				Chest = targ.GetWornForm(0x00000004) as Armor
				UnequipObject(Chest)

				Boots = targ.GetWornForm(0x00000080) as Armor
				UnequipObject(Boots)

				Hands = targ.GetWornForm(0x00000008) as Armor
				UnequipObject(Hands)

				Cloak = targ.GetWornForm(0x00010000) as Armor
				UnequipObject(Cloak)

				Backpack = targ.GetWornForm(0x00020000) as Armor
				UnequipObject(Backpack)

				WeaponObj = targ.GetEquippedWeapon()
				If WeaponObj
					targ.UnequipItem(WeaponObj, true)
				EndIf
			EndIf

			Snore = _SLPQuest._SLPSnoreLP.Play(targ)
			Sound.SetInstanceVolume(Snore, _SLPQuest.SnoreVol)
		EndIf
	EndEvent

	Event OnCellDetach()
		OnUnload()
	EndEvent

	Event OnUnload()
		If targ
			EquipObject(Head)
			EquipObject(Chest)
			EquipObject(Boots)
			EquipObject(Hands)
			EquipObject(Cloak)
			EquipObject(Backpack)
			EquipObject(WeaponObj)
			EquipObject(ShieldObj)
		EndIf
		Sound.StopInstance(Snore)
	EndEvent

	Event OnDetachedFromCell()
		OnUnload()
	EndEvent

	Event OnEffectFinish(Actor akTarget, Actor akCaster)
		OnUnload()
	EndEvent

EndState

State Bandit

	Event OnBeginState()
		If targ
			If _SLPQuest.SKSEInstalled
				Head = targ.GetWornForm(0x00000002) as Armor
				UnequipObject(Head)

				;Chest = targ.GetWornForm(0x00000004) as Armor
				;UnequipObject(Chest)

				Boots = targ.GetWornForm(0x00000080) as Armor
				UnequipObject(Boots)

				Hands = targ.GetWornForm(0x00000008) as Armor
				UnequipObject(Hands)

				Cloak = targ.GetWornForm(0x00010000) as Armor
				UnequipObject(Cloak)

				Backpack = targ.GetWornForm(0x00020000) as Armor
				UnequipObject(Backpack)

				WeaponObj = targ.GetEquippedWeapon()
				If WeaponObj
					targ.UnequipItem(WeaponObj, true)
				EndIf

				ShieldObj = targ.GetEquippedShield()
				UnequipObject(ShieldObj)
			EndIf

			Snore = _SLPQuest._SLPSnoreLP.Play(targ)
			Sound.SetInstanceVolume(Snore, _SLPQuest.SnoreVol)
		EndIf
	EndEvent

	Event OnCellDetach()
		OnUnload()
	EndEvent

	Event OnUnload()
		If targ
			EquipObject(Head)
			;EquipObject(Chest)
			EquipObject(Boots)
			EquipObject(Hands)
			EquipObject(Cloak)
			EquipObject(Backpack)
			EquipObject(WeaponObj)
			EquipObject(ShieldObj)
		EndIf
		Sound.StopInstance(Snore)
	EndEvent

	Event OnDetachedFromCell()
		OnUnload()
	EndEvent

	Event OnEffectFinish(Actor akTarget, Actor akCaster)
		OnUnload()
	EndEvent

	Event OnDying(Actor akKiller)
		GoToState("Dead")
	EndEvent

EndState

State Robe

	Event OnBeginState()
		If targ
			If _SLPQuest.SKSEInstalled

				Head = targ.GetWornForm(0x00000002) as Armor
				UnequipObject(Head)

				Chest = targ.GetWornForm(0x00000004) as Armor
				UnequipObject(Chest)

				Boots = targ.GetWornForm(0x00000080) as Armor
				UnequipObject(Boots)

				Hands = targ.GetWornForm(0x00000008) as Armor
				UnequipObject(Hands)

				Cloak = targ.GetWornForm(0x00010000) as Armor
				UnequipObject(Cloak)

				Backpack = targ.GetWornForm(0x00020000) as Armor
				UnequipObject(Backpack)

				iRandomIndex = Utility.RandomInt(1, _SLPQuest._SLPRobesList.GetSize()) - 1
				RandomRobes = _SLPQuest._SLPRobesList.GetAt(iRandomIndex) as Armor
				If RandomRobes
					targ.AddItem(RandomRobes)
					targ.EquipItem(RandomRobes, true)
				EndIf

				WeaponObj = targ.GetEquippedWeapon()
				If WeaponObj
					targ.UnequipItem(WeaponObj, true)
				EndIf
			EndIf

			Snore = _SLPQuest._SLPSnoreLP.Play(targ)
			Sound.SetInstanceVolume(Snore, _SLPQuest.SnoreVol)
		EndIf
	EndEvent

	Event OnCellDetach()
		OnUnload()
	EndEvent

	Event OnUnload()
		If targ
			targ.RemoveItem(RandomRobes)
			EquipObject(Head)
			EquipObject(Chest)
			EquipObject(Boots)
			EquipObject(Hands)
			EquipObject(Cloak)
			EquipObject(Backpack)
			EquipObject(WeaponObj)
			EquipObject(ShieldObj)
		EndIf
		Sound.StopInstance(Snore)
	EndEvent

	Event OnDetachedFromCell()
		OnUnload()
	EndEvent

	Event OnEffectFinish(Actor akTarget, Actor akCaster)
		OnUnload()
	EndEvent

EndState

State Snore

	Event OnBeginState()
		If targ
			Snore = _SLPQuest._SLPSnoreLP.Play(targ)
			Sound.SetInstanceVolume(Snore, _SLPQuest.SnoreVol)
		EndIf
	EndEvent

	Event OnCellDetach()
		OnUnload()
	EndEvent

	Event OnUnload()
		Sound.StopInstance(Snore)
	EndEvent

	Event OnDetachedFromCell()
		OnUnload()
	EndEvent

	Event OnEffectFinish(Actor akTarget, Actor akCaster)
		OnUnload()
	EndEvent

EndState

State Dead
EndState