Scriptname _SLPQuestScript extends Quest  

;====================================================================================

Spell Property _SLPPlayerSpell Auto

Faction Property BanditFaction Auto

FormList Property _SLPRobesList Auto

Sound Property _SLPSnoreLP Auto

_SLPSkyUIConfig Property _SLPSKConfigQuest Auto

Float Property fModVersion Auto
Float Property SnoreVol = 1.0 Auto

Int Property SleepWear = 2 Auto
Int Property SleepHostile = 2 Auto

Bool Property SkyInstalled Auto
Bool Property SKSEInstalled Auto
Bool Property ModUpdated Auto
Bool Property ModRestarted Auto
Bool Property Follower = True Auto

Actor Property PlayerRef Auto
Actor targ

;====================================================================================

Function Maintenance()
	targ = PlayerRef
	;Debug.Trace("")
	;Debug.Trace("=====Sleep Tight is refreshing itself and searching for addons. Any errors below are harmless.=====")
	;Debug.Trace("")

	If (SKSE.GetVersion() + SKSE.GetVersionMinor() * 0.01 + SKSE.GetVersionBeta() * 0.0001) >= 1.0605
		SKSEInstalled = True
	Else
		Debug.Notification("Sleep Tight: SKSE 1.6.5+ not detected. Some features will be disabled.")
		SKSEInstalled = False
	EndIf

	If Game.GetFormFromFile(0x00000802, "SkyUI.esp")		;SkyUI
		SkyInstalled = True
	Else
		SkyInstalled = False
	EndIf

	If fModVersion
		If fModVersion < 1.04			;CHANGE VERSION NUMBER WHEN UPDATING
			ModUpdated = True
			Restart()
			Debug.Notification("Sleep Tight: Updated to v1.04")	;CHANGE VERSION NUMBER WHEN UPDATING
		EndIf
		If SkyInstalled && SKSEInstalled
			_SLPSKConfigQuest.OnConfigInit()
		EndIf
	Else
		targ.AddSpell(_SLPPlayerSpell, false)
	EndIf
	fModVersion = 1.04			;CHANGE VERSION NUMBER WHEN UPDATING
	ModUpdated = False
	;Debug.Trace("")
	;Debug.Trace("=====Sleep Tight is finished refreshing itself and searching for addons!=====")
	;Debug.Trace("")
EndFunction

;====================================================================================

Function Restart()
	ModRestarted = True
	targ = PlayerRef
	targ.RemoveSpell(_SLPPlayerSpell)
	Utility.Wait(0.5)
	targ.AddSpell(_SLPPlayerSpell, false)
	Utility.Wait(1.0)
	ModRestarted = False
EndFunction

;====================================================================================

Event OnInit()
	Maintenance()
EndEvent