Scriptname _SLPQuestStart extends activemagiceffect  

;====================================================================================

Quest Property _SLPApplyNPCQuest Auto
Quest Property _SLPApplyNPCNoFollowerQuest Auto
Quest Property _SLPApplyNPCHostileQuest Auto

_SLPQuestScript Property _SLPQuest Auto

Bool Finished

;====================================================================================
 
Event OnEffectStart(Actor akTarget, Actor akCaster)
	GoToState("Start")
EndEvent

State Start

	Event OnBeginState()
		If _SLPQuest.Follower
			_SLPApplyNPCQuest.Start()
		Else
			_SLPApplyNPCNoFollowerQuest.Start()
		EndIf
		If _SLPQuest.SleepHostile > 0
			_SLPApplyNPCHostileQuest.Start()
		EndIf
		GoToState("Wait")
	EndEvent

EndState

State Wait

	Event OnLocationChange(Location akOldLoc, Location akNewLoc)
		Utility.Wait(0.75)
		If !Finished
			_SLPApplyNPCQuest.Stop()
			_SLPApplyNPCNoFollowerQuest.Stop()
			_SLPApplyNPCHostileQuest.Stop()
			If _SLPQuest.Follower
				_SLPApplyNPCQuest.Start()
			Else
				_SLPApplyNPCNoFollowerQuest.Start()
			EndIf
			If _SLPQuest.SleepHostile > 0
				_SLPApplyNPCHostileQuest.Start()
			EndIf
		EndIf
	EndEvent

	Event OnEffectFinish(Actor akTarget, Actor akCaster)
		Finished = True
		_SLPApplyNPCQuest.Stop()
		_SLPApplyNPCNoFollowerQuest.Stop()
		_SLPApplyNPCHostileQuest.Stop()
		GoToState("Dead")
	EndEvent

EndState

State Dead
EndState